package eu.jonahbauer.wizard.client.libgdx.screens;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;
import com.badlogic.gdx.scenes.scene2d.ui.TextField;
import com.badlogic.gdx.scenes.scene2d.utils.ChangeListener;
import com.badlogic.gdx.utils.Align;
import eu.jonahbauer.wizard.client.libgdx.WizardGame;

public class ConnectScreen extends MenuScreen {

    private TextButton buttonBack;
    private TextButton buttonConnect;

    private TextField uri;

    private final ChangeListener listener = new ChangeListener() {
        @Override
        public void changed(ChangeEvent event, Actor actor) {
            if (actor == buttonBack) {
                game.setScreen(new MainMenuScreen(game, data));
                sfxClick();
            } else if (actor == buttonConnect) {
                game.setScreen(new LobbyScreen(game, data));
                sfxClick();
            }
        }
    };

    public ConnectScreen(WizardGame game, Data data) {
        super(game, data);
    }

    @Override
    public void show() {
        super.show();

        buttonBack = new TextButton(game.messages.get("menu.connect.back"), data.skin);
        buttonBack.setPosition(WizardGame.WIDTH * 0.275f, BUTTON_BAR_Y);
        buttonConnect = new TextButton(game.messages.get("menu.connect.connect"), data.skin);
        buttonConnect.setPosition(WizardGame.WIDTH * 0.725f - buttonConnect.getWidth(), BUTTON_BAR_Y);

        var label = new Label(game.messages.get("menu.connect.address.label"), data.skin);
        label.setSize(0.4f * WizardGame.WIDTH, 64);
        label.setAlignment(Align.center);
        label.setPosition(0.5f * (WizardGame.WIDTH - label.getWidth()), 0.55f * (WizardGame.HEIGHT - label.getHeight()));

        uri = new TextField("", data.skin);
        uri.setMessageText("wss://localhost/wizard");
        uri.setSize(0.4f * WizardGame.WIDTH, 64);
        uri.setPosition(0.5f * (WizardGame.WIDTH - uri.getWidth()), 0.45f * (WizardGame.HEIGHT - uri.getHeight()));

        Gdx.input.setInputProcessor(data.stage);
        data.stage.addActor(buttonBack);
        data.stage.addActor(buttonConnect);
        data.stage.addActor(uri);
        data.stage.addActor(label);

        buttonBack.addListener(listener);
        buttonConnect.addListener(listener);
    }

    @Override
    protected void renderInternal(float delta) {}
}
