package eu.jonahbauer.wizard.client.libgdx.screens;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;
import com.badlogic.gdx.scenes.scene2d.ui.TextField;
import com.badlogic.gdx.scenes.scene2d.utils.ChangeListener;
import eu.jonahbauer.wizard.client.libgdx.WizardGame;

public class CreateGameScreen extends MenuScreen {
    TextButton backButton;
    TextButton continueButton;

    TextField option1;
    TextField option2;
    TextField option3;
    TextField option4;
    TextField option5;
    TextField option6;

    ChangeListener listener = new ChangeListener() {
        @Override
        public void changed(ChangeEvent event, Actor actor) {
            if (actor == backButton) {
                game.setScreen(new LobbyScreen(game, data));
                sfxClick();
            } else if (actor == continueButton) {
                game.setScreen(new WaitingScreen(game, data));
                sfxClick();
            }
        }
    };

    public CreateGameScreen(WizardGame game, Data data) {
        super(game, data);
    }

    @Override
    public void show() {
        super.show();

        backButton = new TextButton("Zurück", data.skin);
        backButton.setPosition(WizardGame.WIDTH * 0.275f, BUTTON_BAR_Y);
        continueButton = new TextButton("Erstellen", data.skin);
        continueButton.setPosition(WizardGame.WIDTH * 0.725f - continueButton.getWidth(), BUTTON_BAR_Y);

        option1 = new TextField("1", data.skin);
        option1.setPosition(WizardGame.WIDTH * 0.3f, WizardGame.HEIGHT * 0.6f);
        option1.setSize(250, continueButton.getHeight());
        option2 = new TextField("2", data.skin);
        option2.setPosition(option1.getX(), option1.getY() - WizardGame.HEIGHT * 0.12f);
        option2.setSize(250, continueButton.getHeight());
        option3 = new TextField("3", data.skin);
        option3.setPosition(option2.getX(), option2.getY() - WizardGame.HEIGHT * 0.12f);
        option3.setSize(250, continueButton.getHeight());

        option4 = new TextField("4", data.skin);
        option4.setPosition(WizardGame.WIDTH * 0.65f - option4.getWidth(), option1.getY());
        option4.setSize(250, continueButton.getHeight());
        option5 = new TextField("5", data.skin);
        option5.setPosition(option4.getX(), option2.getY());
        option5.setSize(250, continueButton.getHeight());
        option6 = new TextField("6", data.skin);
        option6.setPosition(option4.getX(), option3.getY());
        option6.setSize(250, continueButton.getHeight());

        Gdx.input.setInputProcessor(data.stage);
        data.stage.addActor(backButton);
        data.stage.addActor(continueButton);
        data.stage.addActor(option1);
        data.stage.addActor(option2);
        data.stage.addActor(option3);
        data.stage.addActor(option4);
        data.stage.addActor(option5);
        data.stage.addActor(option6);

        backButton.addListener(listener);
        continueButton.addListener(listener);
    }

    @Override
    protected void renderInternal(float delta) {}
}
