package eu.jonahbauer.wizard.server.machine;

import eu.jonahbauer.wizard.common.machine.State;
import eu.jonahbauer.wizard.common.messages.client.ClientMessage;
import eu.jonahbauer.wizard.common.messages.server.NackMessage;
import org.springframework.web.socket.CloseStatus;

import java.util.Optional;

public interface ClientState extends State<ClientState, Player> {
    default Optional<ClientState> onOpen(Player player) {
        throw new IllegalStateException(); // TODO nachdenken
    }

    default Optional<ClientState> onMessage(Player player, ClientMessage message) {
        player.send(new NackMessage(NackMessage.BAD_REQUEST, "Unexpected message."));
        return Optional.empty();
    }

    Optional<ClientState> onClose(Player player, CloseStatus status);
}
