package eu.jonahbauer.wizard.server.machine;

import eu.jonahbauer.wizard.common.machine.Context;
import eu.jonahbauer.wizard.common.messages.client.ClientMessage;
import eu.jonahbauer.wizard.common.messages.server.ServerMessage;
import eu.jonahbauer.wizard.server.machine.states.CreatedState;
import lombok.SneakyThrows;
import org.springframework.web.socket.CloseStatus;
import org.springframework.web.socket.TextMessage;
import org.springframework.web.socket.WebSocketSession;

public class Player extends Context<ClientState, Player> {
    private final WebSocketSession session;

    public Player(WebSocketSession session) {
        super(new CreatedState());
        this.session = session;
    }

    @Override
    protected void handleError(Throwable t) {

    }

    public void onOpen() {
        execute(s -> s.onOpen(this));
    }

    public void onMessage(ClientMessage message) {
        execute(s -> s.onMessage(this, message));
    }

    public void onClose(CloseStatus status) {
        execute(s -> s.onClose(this, status));
    }

    @SneakyThrows
    public void send(ServerMessage message) {
        synchronized (session) {
            session.sendMessage(new TextMessage(message.toString()));
        }
    }
}
