package eu.jonahbauer.wizard.server.machine.states;

import eu.jonahbauer.wizard.common.messages.client.ClientMessage;
import eu.jonahbauer.wizard.common.messages.client.LeaveSessionMessage;
import eu.jonahbauer.wizard.common.messages.server.NackMessage;
import eu.jonahbauer.wizard.common.messages.server.StartingGameMessage;
import eu.jonahbauer.wizard.server.machine.ClientState;
import eu.jonahbauer.wizard.server.machine.Player;
import org.springframework.web.socket.CloseStatus;

import java.util.Optional;

public class InGame implements ClientState {
    @Override
    public Optional<ClientState> onEnter(Player context) {
        context.send(new StartingGameMessage());

        return ClientState.super.onEnter(context);
    }

    @Override
    public void onExit(Player context) {
        ClientState.super.onExit(context);
    }

    @Override
    public Optional<ClientState> onOpen(Player player) {
        return Optional.empty();
    }

    @Override
    public Optional<ClientState> onMessage(Player player, ClientMessage message) {
        if(message instanceof LeaveSessionMessage) {
            //?
            return Optional.empty();
        } else {
            player.send(new NackMessage(0, "Error: Invalid Message!"));
            return Optional.empty();
        }
    }

    @Override
    public Optional<ClientState> onClose(Player player, CloseStatus status) {
        return Optional.empty();
    }
}
